## GstEvent

GstEvent — Structure describing events that are passed up and down a pipeline

## Functions

#define | GST_EVENT_MAKE_TYPE()
#define | GST_EVENT_TYPE()
#define | GST_EVENT_TYPE_NAME()
#define | GST_EVENT_TIMESTAMP()
#define | GST_EVENT_SEQNUM()
#define | GST_EVENT_IS_UPSTREAM()
#define | GST_EVENT_IS_DOWNSTREAM()
#define | GST_EVENT_IS_SERIALIZED()
#define | GST_EVENT_IS_STICKY()
GstEventTypeFlags | gst_event_type_get_flags ()
const gchar * | gst_event_type_get_name ()
GQuark | gst_event_type_to_quark ()
GstEvent * | gst_event_ref ()
void | gst_event_unref ()
gboolean | gst_event_replace ()
GstEvent * | gst_event_copy ()
GstEvent * | gst_event_steal ()
gboolean | gst_event_take ()
#define | gst_event_is_writable()
#define | gst_event_make_writable()
GstStructure * | gst_event_writable_structure ()
GstEvent * | gst_event_new_custom ()
const GstStructure * | gst_event_get_structure ()
gboolean | gst_event_has_name ()
guint32 | gst_event_get_seqnum ()
void | gst_event_set_seqnum ()
gint64 | gst_event_get_running_time_offset ()
void | gst_event_set_running_time_offset ()
GstEvent * | gst_event_new_flush_start ()
GstEvent * | gst_event_new_flush_stop ()
void | gst_event_parse_flush_stop ()
GstEvent * | gst_event_new_eos ()
GstEvent * | gst_event_new_gap ()
void | gst_event_parse_gap ()
GstEvent * | gst_event_new_stream_start ()
void | gst_event_parse_stream_start ()
void | gst_event_set_stream_flags ()
void | gst_event_parse_stream_flags ()
void | gst_event_set_group_id ()
gboolean | gst_event_parse_group_id ()
void | gst_event_set_stream ()
void | gst_event_parse_stream ()
GstEvent * | gst_event_new_segment ()
void | gst_event_parse_segment ()
void | gst_event_copy_segment ()
GstEvent * | gst_event_new_tag ()
void | gst_event_parse_tag ()
GstEvent * | gst_event_new_buffer_size ()
void | gst_event_parse_buffer_size ()
GstEvent * | gst_event_new_qos ()
void | gst_event_parse_qos ()
GstEvent * | gst_event_new_seek ()
void | gst_event_parse_seek ()
void | gst_event_set_seek_trickmode_interval ()
void | gst_event_parse_seek_trickmode_interval ()
GstEvent * | gst_event_new_navigation ()
GstEvent * | gst_event_new_latency ()
void | gst_event_parse_latency ()
GstEvent * | gst_event_new_step ()
void | gst_event_parse_step ()
GstEvent * | gst_event_new_sink_message ()
void | gst_event_parse_sink_message ()
GstEvent * | gst_event_new_reconfigure ()
GstEvent * | gst_event_new_caps ()
void | gst_event_parse_caps ()
GstEvent * | gst_event_new_toc ()
void | gst_event_parse_toc ()
GstEvent * | gst_event_new_toc_select ()
void | gst_event_parse_toc_select ()
GstEvent * | gst_event_new_segment_done ()
void | gst_event_parse_segment_done ()
GstEvent * | gst_event_new_protection ()
void | gst_event_parse_protection ()
GstEvent * | gst_event_new_select_streams ()
void | gst_event_parse_select_streams ()
GstEvent * | gst_event_new_stream_collection ()
void | gst_event_parse_stream_collection ()
GstEvent * | gst_event_new_stream_group_done ()
void | gst_event_parse_stream_group_done ()

## Types and Values

struct | GstEvent
enum | GstEventTypeFlags
#define | GST_EVENT_TYPE_BOTH
enum | GstEventType
enum | GstStreamFlags
enum | GstQOSType
enum | GstSeekType
enum | GstSeekFlags

## Object Hierarchy

        GBoxed
        ╰── GstEvent

## Includes

    #include <gst/gst.h>

## Description

The event class provides factory methods to construct events for sending and functions to query (parse) received events.

Events are usually created with gst_event_new_*() which takes event-type specific parameters as arguments. To send an event application will usually use `gst_element_send_event()` and elements will use `gst_pad_send_event()` or `gst_pad_push_event()`. The event should be unreffed with `gst_event_unref()` if it has not been sent.

Events that have been received can be parsed with their respective gst_event_parse_*() functions. It is valid to pass `NULL` for unwanted details.

Events are passed between elements in parallel to the data stream. Some events are serialized with buffers, others are not. Some events only travel downstream, others only upstream. Some events can travel both upstream and downstream.

The events are used to signal special conditions in the datastream such as EOS (end of stream) or the start of a new stream-segment. Events are also used to flush the pipeline of any pending data.

Most of the event API is used inside plugins. Applications usually only construct and use seek events. To do that `gst_event_new_seek()` is used to create a seek event. It takes the needed parameters to specify seeking time and mode.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15

    GstEvent *event;
    gboolean result;
    ...
    // construct a seek event to play the media from second 2 to 5, flush
    // the pipeline to decrease latency.
    event = gst_event_new_seek (1.0,
       GST_FORMAT_TIME,
       GST_SEEK_FLAG_FLUSH,
       GST_SEEK_TYPE_SET, 2 * GST_SECOND,
       GST_SEEK_TYPE_SET, 5 * GST_SECOND);
    ...
    result = gst_element_send_event (pipeline, event);
    if (!result)
      g_warning ("seek failed");
    ...

## Functions

### GST_EVENT_MAKE_TYPE()

    #define             GST_EVENT_MAKE_TYPE(num,flags)

when making custom event types, use this macro with the num and the given flags

#### Parameters

num | the event number to create |
flags | the event flags |

### GST_EVENT_TYPE()

    #define GST_EVENT_TYPE(event)           (GST_EVENT_CAST(event)->type)

Get the GstEventType of the event.

#### Parameters

event | the event to query |

### GST_EVENT_TYPE_NAME()

    #define GST_EVENT_TYPE_NAME(event)      (gst_event_type_get_name(GST_EVENT_TYPE(event)))

Get a constant string representation of the GstEventType of the event.

#### Parameters

event | the event to query |

### GST_EVENT_TIMESTAMP()

    #define GST_EVENT_TIMESTAMP(event)      (GST_EVENT_CAST(event)->timestamp)

Get the GstClockTime timestamp of the event. This is the time when the event was created.

#### Parameters

event | the event to query |

### GST_EVENT_SEQNUM()

    #define GST_EVENT_SEQNUM(event)         (GST_EVENT_CAST(event)->seqnum)

The sequence number of `event` .

#### Parameters

event | the event to query |

### GST_EVENT_IS_UPSTREAM()

    #define GST_EVENT_IS_UPSTREAM(ev)       !!(GST_EVENT_TYPE (ev) & GST_EVENT_TYPE_UPSTREAM)

Check if an event can travel upstream.

#### Parameters

ev | the event to query |

### GST_EVENT_IS_DOWNSTREAM()

    #define GST_EVENT_IS_DOWNSTREAM(ev)     !!(GST_EVENT_TYPE (ev) & GST_EVENT_TYPE_DOWNSTREAM)

Check if an event can travel downstream.

#### Parameters

ev | the event to query |

### GST_EVENT_IS_SERIALIZED()

    #define GST_EVENT_IS_SERIALIZED(ev)     !!(GST_EVENT_TYPE (ev) & GST_EVENT_TYPE_SERIALIZED)

Check if an event is serialized with the data stream.

#### Parameters

ev | the event to query |

### GST_EVENT_IS_STICKY()

    #define GST_EVENT_IS_STICKY(ev)     !!(GST_EVENT_TYPE (ev) & GST_EVENT_TYPE_STICKY)

Check if an event is sticky on the pads.

#### Parameters

ev | the event to query |

### gst_event_type_get_flags ()

    GstEventTypeFlags
    gst_event_type_get_flags (GstEventType type);

Gets the GstEventTypeFlags associated with `type` .

#### Parameters

type | a GstEventType |

#### Returns

a GstEventTypeFlags.

### gst_event_type_get_name ()

    const gchar *
    gst_event_type_get_name (GstEventType type);

Get a printable name for the given event type. Do not modify or free.

#### Parameters

type | the event type |

#### Returns

a reference to the static name of the event.

### gst_event_type_to_quark ()

    GQuark
    gst_event_type_to_quark (GstEventType type);

Get the unique quark for the given event type.

#### Parameters

type | the event type |

#### Returns

the quark associated with the event type

### gst_event_ref ()

    GstEvent *
    gst_event_ref (GstEvent *event);

Increase the refcount of this event.

#### Parameters

event | The event to refcount |

#### Returns

`event` (for convenience when doing assignments).

[transfer full]

### gst_event_unref ()

    void
    gst_event_unref (GstEvent *event);

Decrease the refcount of an event, freeing it if the refcount reaches 0.

#### Parameters

event | the event to refcount. | [transfer full]

### gst_event_replace ()

    gboolean
    gst_event_replace (GstEvent **old_event,
                       GstEvent *new_event);

Modifies a pointer to a GstEvent to point to a different GstEvent. The modification is done atomically (so this is useful for ensuring thread safety in some cases), and the reference counts are updated appropriately (the old event is unreffed, the new one is reffed).

Either `new_event` or the GstEvent pointed to by `old_event` may be `NULL`.

#### Parameters

old_event | pointer to a pointer to a GstEvent to be replaced. | [inout][transfer full][nullable]
new_event | pointer to a GstEvent that will replace the event pointed to by `old_event` . | [allow-none][transfer none]

#### Returns

`TRUE` if `new_event` was different from `old_event`

### gst_event_copy ()

    GstEvent *
    gst_event_copy (const GstEvent *event);

Copy the event using the event specific copy function.

#### Parameters

event | The event to copy |

#### Returns

the new event.

[transfer full]

### gst_event_steal ()

    GstEvent *
    gst_event_steal (GstEvent **old_event);

Atomically replace the GstEvent pointed to by `old_event` with `NULL` and return the original event.

#### Parameters

old_event | pointer to a pointer to a GstEvent to be stolen. | [inout][transfer full][nullable]

#### Returns

the GstEvent that was in `old_event`

### gst_event_take ()

    gboolean
    gst_event_take (GstEvent **old_event,
                    GstEvent *new_event);

Modifies a pointer to a GstEvent to point to a different GstEvent. This function is similar to `gst_event_replace()` except that it takes ownership of `new_event` .

Either `new_event` or the GstEvent pointed to by `old_event` may be `NULL`.

#### Parameters

old_event | pointer to a pointer to a GstEvent to be stolen. | [inout][transfer full][nullable]
new_event | pointer to a GstEvent that will replace the event pointed to by `old_event` . | [allow-none][transfer full]

#### Returns

`TRUE` if `new_event` was different from `old_event`

### gst_event_is_writable()

    #define         gst_event_is_writable(ev)     gst_mini_object_is_writable (GST_MINI_OBJECT_CAST (ev))

Tests if you can safely write data into a event's structure or validly modify the seqnum and timestamp field.

#### Parameters

ev | a GstEvent |

### gst_event_make_writable()

    #define         gst_event_make_writable(ev)   GST_EVENT_CAST (gst_mini_object_make_writable (GST_MINI_OBJECT_CAST (ev)))

Makes a writable event from the given event. If the source event is already writable, this will simply return the same event. A copy will otherwise be made using `gst_event_copy()`.

#### Parameters

ev | a GstEvent. | [transfer full]

#### Returns

a writable event which may or may not be the same as `ev` .

[transfer full]

### gst_event_writable_structure ()

    GstStructure *
    gst_event_writable_structure (GstEvent *event);

Get a writable version of the structure.

#### Parameters

event | The GstEvent. |

#### Returns

The structure of the event. The structure is still owned by the event, which means that you should not free it and that the pointer becomes invalid when you free the event. This function checks if `event` is writable and will never return `NULL`.

MT safe.

[transfer none]

### gst_event_new_custom ()

    GstEvent *
    gst_event_new_custom (GstEventType type,
                          GstStructure *structure);

Create a new custom-typed event. This can be used for anything not handled by other event-specific functions to pass an event to another element.

Make sure to allocate an event type with the GST_EVENT_MAKE_TYPE macro, assigning a free number and filling in the correct direction and serialization flags.

New custom events can also be created by subclassing the event type if needed.

#### Parameters

type | The type of the new event |
structure | the structure for the event. The event will take ownership of the structure. | [transfer full]

#### Returns

the new custom event.

[transfer full][nullable]

### gst_event_get_structure ()

    const GstStructure *
    gst_event_get_structure (GstEvent *event);

Access the structure of the event.

#### Parameters

event | The GstEvent. |

#### Returns

The structure of the event. The structure is still owned by the event, which means that you should not free it and that the pointer becomes invalid when you free the event.

MT safe.

[transfer none][nullable]

### gst_event_has_name ()

    gboolean
    gst_event_has_name (GstEvent *event,
                        const gchar *name);

Checks if `event` has the given `name` . This function is usually used to check the name of a custom event.

#### Parameters

event | The GstEvent. |
name | name to check |

#### Returns

`TRUE` if `name` matches the name of the event structure.

### gst_event_get_seqnum ()

    guint32
    gst_event_get_seqnum (GstEvent *event);

Retrieve the sequence number of a event.

Events have ever-incrementing sequence numbers, which may also be set explicitly via `gst_event_set_seqnum()`. Sequence numbers are typically used to indicate that a event corresponds to some other set of events or messages, for example an EOS event corresponding to a SEEK event. It is considered good practice to make this correspondence when possible, though it is not required.

Note that events and messages share the same sequence number incrementor; two events or messages will never have the same sequence number unless that correspondence was made explicitly.

#### Parameters

event | A GstEvent. |

#### Returns

The event's sequence number.

MT safe.

### gst_event_set_seqnum ()

    void
    gst_event_set_seqnum (GstEvent *event,
                          guint32 seqnum);

Set the sequence number of a event.

This function might be called by the creator of a event to indicate that the event relates to other events or messages. See `gst_event_get_seqnum()` for more information.

MT safe.

#### Parameters

event | A GstEvent. |
seqnum | A sequence number. |

### gst_event_get_running_time_offset ()

    gint64
    gst_event_get_running_time_offset (GstEvent *event);

Retrieve the accumulated running time offset of the event.

Events passing through GstPads that have a running time offset set via `gst_pad_set_offset()` will get their offset adjusted according to the pad's offset.

If the event contains any information that related to the running time, this information will need to be updated before usage with this offset.

#### Parameters

event | A GstEvent. |

#### Returns

The event's running time offset

MT safe.

Since: 1.4

### gst_event_set_running_time_offset ()

    void
    gst_event_set_running_time_offset (GstEvent *event,
                                       gint64 offset);

Set the running time offset of a event. See `gst_event_get_running_time_offset()` for more information.

MT safe.

#### Parameters

event | A GstEvent. |
offset | A the new running time offset |

Since: 1.4

### gst_event_new_flush_start ()

    GstEvent *
    gst_event_new_flush_start (void);

Allocate a new flush start event. The flush start event can be sent upstream and downstream and travels out-of-bounds with the dataflow.

It marks pads as being flushing and will make them return GST_FLOW_FLUSHING when used for data flow with `gst_pad_push()`, `gst_pad_chain()`, `gst_pad_get_range()` and `gst_pad_pull_range()`. Any event (except a GST_EVENT_FLUSH_STOP) received on a flushing pad will return `FALSE` immediately.

Elements should unlock any blocking functions and exit their streaming functions as fast as possible when this event is received.

This event is typically generated after a seek to flush out all queued data in the pipeline so that the new media is played as soon as possible.

#### Returns

a new flush start event.

[transfer full]

### gst_event_new_flush_stop ()

    GstEvent *
    gst_event_new_flush_stop (gboolean reset_time);

Allocate a new flush stop event. The flush stop event can be sent upstream and downstream and travels serialized with the dataflow. It is typically sent after sending a FLUSH_START event to make the pads accept data again.

Elements can process this event synchronized with the dataflow since the preceding FLUSH_START event stopped the dataflow.

This event is typically generated to complete a seek and to resume dataflow.

#### Parameters

reset_time | if time should be reset |

#### Returns

a new flush stop event.

[transfer full]

### gst_event_parse_flush_stop ()

    void
    gst_event_parse_flush_stop (GstEvent *event,
                                gboolean *reset_time);

Parse the FLUSH_STOP event and retrieve the `reset_time` member.

#### Parameters

event | The event to parse |
reset_time | if time should be reset. | [out]

### gst_event_new_eos ()

    GstEvent *
    gst_event_new_eos (void);

Create a new EOS event. The eos event can only travel downstream synchronized with the buffer flow. Elements that receive the EOS event on a pad can return GST_FLOW_EOS as a GstFlowReturn when data after the EOS event arrives.

The EOS event will travel down to the sink elements in the pipeline which will then post the GST_MESSAGE_EOS on the bus after they have finished playing any buffered data.

When all sinks have posted an EOS message, an EOS message is forwarded to the application.

The EOS event itself will not cause any state transitions of the pipeline.

#### Returns

the new EOS event.

[transfer full]

### gst_event_new_gap ()

    GstEvent *
    gst_event_new_gap (GstClockTime timestamp,
                       GstClockTime duration);

Create a new GAP event. A gap event can be thought of as conceptually equivalent to a buffer to signal that there is no data for a certain amount of time. This is useful to signal a gap to downstream elements which may wait for data, such as muxers or mixers or overlays, especially for sparse streams such as subtitle streams.

#### Parameters

timestamp | the start time (pts) of the gap |
duration | the duration of the gap |

#### Returns

the new GAP event.

[transfer full]

### gst_event_parse_gap ()

    void
    gst_event_parse_gap (GstEvent *event,
                         GstClockTime *timestamp,
                         GstClockTime *duration);

Extract timestamp and duration from a new GAP event.

#### Parameters

event | a GstEvent of type GST_EVENT_GAP |
timestamp | location where to store the start time (pts) of the gap, or `NULL`. | [out][allow-none]
duration | location where to store the duration of the gap, or `NULL`. | [out][allow-none]

### gst_event_new_stream_start ()

    GstEvent *
    gst_event_new_stream_start (const gchar *stream_id);

Create a new STREAM_START event. The stream start event can only travel downstream synchronized with the buffer flow. It is expected to be the first event that is sent for a new stream.

Source elements, demuxers and other elements that create new streams are supposed to send this event as the first event of a new stream. It should not be sent after a flushing seek or in similar situations and is used to mark the beginning of a new logical stream. Elements combining multiple streams must ensure that this event is only forwarded downstream once and not for every single input stream.

The `stream_id` should be a unique string that consists of the upstream stream-id, / as separator and a unique stream-id for this specific stream. A new stream-id should only be created for a stream if the upstream stream is split into (potentially) multiple new streams, e.g. in a demuxer, but not for every single element in the pipeline. `gst_pad_create_stream_id()` or `gst_pad_create_stream_id_printf()` can be used to create a stream-id. There are no particular semantics for the stream-id, though it should be deterministic (to support stream matching) and it might be used to order streams (besides any information conveyed by stream flags).

#### Parameters

stream_id | Identifier for this stream |

#### Returns

the new STREAM_START event.

[transfer full]

### gst_event_parse_stream_start ()

    void
    gst_event_parse_stream_start (GstEvent *event,
                                  const gchar **stream_id);

Parse a stream-id `event` and store the result in the given `stream_id` location. The string stored in `stream_id` must not be modified and will remain valid only until `event` gets freed. Make a copy if you want to modify it or store it for later use.

#### Parameters

event | a stream-start event. |
stream_id | pointer to store the stream-id. | [out][transfer none]

### gst_event_set_stream_flags ()

    void
    gst_event_set_stream_flags (GstEvent *event,
                                GstStreamFlags flags);

#### Parameters

event | a stream-start event |
flags | the stream flags to set |

Since: 1.2

### gst_event_parse_stream_flags ()

    void
    gst_event_parse_stream_flags (GstEvent *event,
                                  GstStreamFlags *flags);

#### Parameters

event | a stream-start event |
flags | address of variable where to store the stream flags. | [out]

Since: 1.2

### gst_event_set_group_id ()

    void
    gst_event_set_group_id (GstEvent *event,
                            guint group_id);

All streams that have the same group id are supposed to be played together, i.e. all streams inside a container file should have the same group id but different stream ids. The group id should change each time the stream is started, resulting in different group ids each time a file is played for example.

Use `gst_util_group_id_next()` to get a new group id.

#### Parameters

event | a stream-start event |
group_id | the group id to set |

Since: 1.2

### gst_event_parse_group_id ()

    gboolean
    gst_event_parse_group_id (GstEvent *event,
                              guint *group_id);

#### Parameters

event | a stream-start event |
group_id | address of variable where to store the group id. | [out]

#### Returns

`TRUE` if a group id was set on the event and could be parsed, `FALSE` otherwise.

Since: 1.2

### gst_event_set_stream ()

    void
    gst_event_set_stream (GstEvent *event,
                          GstStream *stream);

Set the `stream` on the stream-start `event`

#### Parameters

event | a stream-start event |
stream | the stream object to set. | [transfer none]

Since: 1.10

### gst_event_parse_stream ()

    void
    gst_event_parse_stream (GstEvent *event,
                            GstStream **stream);

Parse a stream-start `event` and extract the GstStream from it.

#### Parameters

event | a stream-start event |
stream | address of variable to store the stream. | [out][transfer full]

Since: 1.10

### gst_event_new_segment ()

    GstEvent *
    gst_event_new_segment (const GstSegment *segment);

Create a new SEGMENT event for `segment` . The segment event can only travel downstream synchronized with the buffer flow and contains timing information and playback properties for the buffers that will follow.

The segment event marks the range of buffers to be processed. All data not within the segment range is not to be processed. This can be used intelligently by plugins to apply more efficient methods of skipping unneeded data. The valid range is expressed with the `start` and `stop` values.

The time value of the segment is used in conjunction with the start value to convert the buffer timestamps into the stream time. This is usually done in sinks to report the current stream_time. `time` represents the stream_time of a buffer carrying a timestamp of `start` . `time` cannot be -1.

`start` cannot be -1, `stop` can be -1. If there is a valid `stop` given, it must be greater or equal the `start` , including when the indicated playback `rate` is < 0.

The `applied_rate` value provides information about any rate adjustment that has already been made to the timestamps and content on the buffers of the stream. (`rate` * `applied_rate` ) should always equal the rate that has been requested for playback. For example, if an element has an input segment with intended playback `rate` of 2.0 and applied_rate of 1.0, it can adjust incoming timestamps and buffer content by half and output a segment event with `rate` of 1.0 and `applied_rate` of 2.0

After a segment event, the buffer stream time is calculated with:

time + (TIMESTAMP(buf) - start) * ABS (rate * applied_rate)

#### Parameters

segment | a GstSegment. | [transfer none]

#### Returns

the new SEGMENT event.

[transfer full][nullable]

### gst_event_parse_segment ()

    void
    gst_event_parse_segment (GstEvent *event,
                             const GstSegment **segment);

Parses a segment `event` and stores the result in the given `segment` location. `segment` remains valid only until the `event` is freed. Don't modify the segment and make a copy if you want to modify it or store it for later use.

#### Parameters

event | The event to parse |
segment | a pointer to a GstSegment. | [out][transfer none]

### gst_event_copy_segment ()

    void
    gst_event_copy_segment (GstEvent *event,
                            GstSegment *segment);

Parses a segment `event` and copies the GstSegment into the location given by `segment` .

#### Parameters

event | The event to parse |
segment | a pointer to a GstSegment |

### gst_event_new_tag ()

    GstEvent *
    gst_event_new_tag (GstTagList *taglist);

Generates a metadata tag event from the given `taglist` .

The scope of the taglist specifies if the taglist applies to the complete medium or only to this specific stream. As the tag event is a sticky event, elements should merge tags received from upstream with a given scope with their own tags with the same scope and create a new tag event from it.

#### Parameters

taglist | metadata list. The event will take ownership of the taglist. | [transfer full]

#### Returns

a new GstEvent.

[transfer full]

### gst_event_parse_tag ()

    void
    gst_event_parse_tag (GstEvent *event,
                         GstTagList **taglist);

Parses a tag `event` and stores the results in the given `taglist` location. No reference to the taglist will be returned, it remains valid only until the `event` is freed. Don't modify or free the taglist, make a copy if you want to modify it or store it for later use.

#### Parameters

event | a tag event |
taglist | pointer to metadata list. | [out][transfer none]

### gst_event_new_buffer_size ()

    GstEvent *
    gst_event_new_buffer_size (GstFormat format,
                               gint64 minsize,
                               gint64 maxsize,
                               gboolean async);

Create a new buffersize event. The event is sent downstream and notifies elements that they should provide a buffer of the specified dimensions.

When the `async` flag is set, a thread boundary is preferred.

#### Parameters

format | buffer format |
minsize | minimum buffer size |
maxsize | maximum buffer size |
async | thread behavior |

#### Returns

a new GstEvent.

[transfer full]

### gst_event_parse_buffer_size ()

    void
    gst_event_parse_buffer_size (GstEvent *event,
                                 GstFormat *format,
                                 gint64 *minsize,
                                 gint64 *maxsize,
                                 gboolean *async);

Get the format, minsize, maxsize and async-flag in the buffersize event.

#### Parameters

event | The event to query |
format | A pointer to store the format in. | [out]
minsize | A pointer to store the minsize in. | [out]
maxsize | A pointer to store the maxsize in. | [out]
async | A pointer to store the async-flag in. | [out]

### gst_event_new_qos ()

    GstEvent *
    gst_event_new_qos (GstQOSType type,
                       gdouble proportion,
                       GstClockTimeDiff diff,
                       GstClockTime timestamp);

Allocate a new qos event with the given values. The QOS event is generated in an element that wants an upstream element to either reduce or increase its rate because of high/low CPU load or other resource usage such as network performance or throttling. Typically sinks generate these events for each buffer they receive.

`type` indicates the reason for the QoS event. GST_QOS_TYPE_OVERFLOW is used when a buffer arrived in time or when the sink cannot keep up with the upstream datarate. GST_QOS_TYPE_UNDERFLOW is when the sink is not receiving buffers fast enough and thus has to drop late buffers. GST_QOS_TYPE_THROTTLE is used when the datarate is artificially limited by the application, for example to reduce power consumption.

`proportion` indicates the real-time performance of the streaming in the element that generated the QoS event (usually the sink). The value is generally computed based on more long term statistics about the streams timestamps compared to the clock. A value < 1.0 indicates that the upstream element is producing data faster than real-time. A value > 1.0 indicates that the upstream element is not producing data fast enough. 1.0 is the ideal `proportion` value. The proportion value can safely be used to lower or increase the quality of the element.

`diff` is the difference against the clock in running time of the last buffer that caused the element to generate the QOS event. A negative value means that the buffer with `timestamp` arrived in time. A positive value indicates how late the buffer with `timestamp` was. When throttling is enabled, `diff` will be set to the requested throttling interval.

`timestamp` is the timestamp of the last buffer that cause the element to generate the QOS event. It is expressed in running time and thus an ever increasing value.

The upstream element can use the `diff` and `timestamp` values to decide whether to process more buffers. For positive `diff` , all buffers with timestamp <= `timestamp` + `diff` will certainly arrive late in the sink as well. A (negative) `diff` value so that `timestamp` + `diff` would yield a result smaller than 0 is not allowed.

The application can use general event probes to intercept the QoS event and implement custom application specific QoS handling.

#### Parameters

type | the QoS type |
proportion | the proportion of the qos message |
diff | The time difference of the last Clock sync |
timestamp | The timestamp of the buffer |

#### Returns

a new QOS event.

[transfer full][nullable]

### gst_event_parse_qos ()

    void
    gst_event_parse_qos (GstEvent *event,
                         GstQOSType *type,
                         gdouble *proportion,
                         GstClockTimeDiff *diff,
                         GstClockTime *timestamp);

Get the type, proportion, diff and timestamp in the qos event. See `gst_event_new_qos()` for more information about the different QoS values.

`timestamp` will be adjusted for any pad offsets of pads it was passing through.

#### Parameters

event | The event to query |
type | A pointer to store the QoS type in. | [out]
proportion | A pointer to store the proportion in. | [out]
diff | A pointer to store the diff in. | [out]
timestamp | A pointer to store the timestamp in. | [out]

### gst_event_new_seek ()

    GstEvent *
    gst_event_new_seek (gdouble rate,
                        GstFormat format,
                        GstSeekFlags flags,
                        GstSeekType start_type,
                        gint64 start,
                        GstSeekType stop_type,
                        gint64 stop);

Allocate a new seek event with the given parameters.

The seek event configures playback of the pipeline between `start` to `stop` at the speed given in `rate` , also called a playback segment. The `start` and `stop` values are expressed in `format` .

A `rate` of 1.0 means normal playback rate, 2.0 means double speed. Negatives values means backwards playback. A value of 0.0 for the rate is not allowed and should be accomplished instead by PAUSING the pipeline.

A pipeline has a default playback segment configured with a start position of 0, a stop position of -1 and a rate of 1.0. The currently configured playback segment can be queried with GST_QUERY_SEGMENT.

`start_type` and `stop_type` specify how to adjust the currently configured start and stop fields in playback segment. Adjustments can be made relative or absolute to the last configured values. A type of GST_SEEK_TYPE_NONE means that the position should not be updated.

When the rate is positive and `start` has been updated, playback will start from the newly configured start position.

For negative rates, playback will start from the newly configured stop position (if any). If the stop position is updated, it must be different from -1 (GST_CLOCK_TIME_NONE) for negative rates.

It is not possible to seek relative to the current playback position, to do this, PAUSE the pipeline, query the current playback position with GST_QUERY_POSITION and update the playback segment current position with a GST_SEEK_TYPE_SET to the desired position.

#### Parameters

rate | The new playback rate |
format | The format of the seek values |
flags | The optional seek flags |
start_type | The type and flags for the new start position |
start | The value of the new start position |
stop_type | The type and flags for the new stop position |
stop | The value of the new stop position |

#### Returns

a new seek event.

[transfer full][nullable]

### gst_event_parse_seek ()

    void
    gst_event_parse_seek (GstEvent *event,
                          gdouble *rate,
                          GstFormat *format,
                          GstSeekFlags *flags,
                          GstSeekType *start_type,
                          gint64 *start,
                          GstSeekType *stop_type,
                          gint64 *stop);

Parses a seek `event` and stores the results in the given result locations.

#### Parameters

event | a seek event |
rate | result location for the rate. | [out]
format | result location for the stream format. | [out]
flags | result location for the GstSeekFlags. | [out]
start_type | result location for the GstSeekType of the start position. | [out]
start | result location for the start position expressed in `format` . | [out]
stop_type | result location for the GstSeekType of the stop position. | [out]
stop | result location for the stop position expressed in `format` . | [out]

### gst_event_set_seek_trickmode_interval ()

    void
    gst_event_set_seek_trickmode_interval (GstEvent *event,
                                           GstClockTime interval);

Sets a trickmode interval on a (writable) seek event. Elements that support TRICKMODE_KEY_UNITS seeks SHOULD use this as the minimal interval between each frame they may output.

Since: 1.16

### gst_event_parse_seek_trickmode_interval ()

    void
    gst_event_parse_seek_trickmode_interval
                                   (GstEvent *event,
                                    GstClockTime *interval);

Retrieve the trickmode interval that may have been set on a seek event with `gst_event_set_seek_trickmode_interval()`.

#### Parameters

interval | . | [out]

Since: 1.16

### gst_event_new_navigation ()

    GstEvent *
    gst_event_new_navigation (GstStructure *structure);

Create a new navigation event from the given description.

#### Parameters

structure | description of the event. The event will take ownership of the structure. | [transfer full]

#### Returns

a new GstEvent.

[transfer full]

### gst_event_new_latency ()

    GstEvent *
    gst_event_new_latency (GstClockTime latency);

Create a new latency event. The event is sent upstream from the sinks and notifies elements that they should add an additional `latency` to the running time before synchronising against the clock.

The latency is mostly used in live sinks and is always expressed in the time format.

#### Parameters

latency | the new latency value |

#### Returns

a new GstEvent.

[transfer full]

### gst_event_parse_latency ()

    void
    gst_event_parse_latency (GstEvent *event,
                             GstClockTime *latency);

Get the latency in the latency event.

#### Parameters

event | The event to query |
latency | A pointer to store the latency in. | [out]

### gst_event_new_step ()

    GstEvent *
    gst_event_new_step (GstFormat format,
                        guint64 amount,
                        gdouble rate,
                        gboolean flush,
                        gboolean intermediate);

Create a new step event. The purpose of the step event is to instruct a sink to skip `amount` (expressed in `format` ) of media. It can be used to implement stepping through the video frame by frame or for doing fast trick modes.

A rate of <= 0.0 is not allowed. Pause the pipeline, for the effect of rate = 0.0 or first reverse the direction of playback using a seek event to get the same effect as rate < 0.0.

The `flush` flag will clear any pending data in the pipeline before starting the step operation.

The `intermediate` flag instructs the pipeline that this step operation is part of a larger step operation.

#### Parameters

format | the format of `amount` |
amount | the amount of data to step |
rate | the step rate |
flush | flushing steps |
intermediate | intermediate steps |

#### Returns

a new GstEvent.

[transfer full][nullable]

### gst_event_parse_step ()

    void
    gst_event_parse_step (GstEvent *event,
                          GstFormat *format,
                          guint64 *amount,
                          gdouble *rate,
                          gboolean *flush,
                          gboolean *intermediate);

Parse the step event.

#### Parameters

event | The event to query |
format | a pointer to store the format in. | [out][allow-none]
amount | a pointer to store the amount in. | [out][allow-none]
rate | a pointer to store the rate in. | [out][allow-none]
flush | a pointer to store the flush boolean in. | [out][allow-none]
intermediate | a pointer to store the intermediate boolean in. | [out][allow-none]

### gst_event_new_sink_message ()

    GstEvent *
    gst_event_new_sink_message (const gchar *name,
                                GstMessage *msg);

Create a new sink-message event. The purpose of the sink-message event is to instruct a sink to post the message contained in the event synchronized with the stream.

`name` is used to store multiple sticky events on one pad.

#### Parameters

name | a name for the event |
msg | the GstMessage to be posted. | [transfer none]

#### Returns

a new GstEvent.

[transfer full]

### gst_event_parse_sink_message ()

    void
    gst_event_parse_sink_message (GstEvent *event,
                                  GstMessage **msg);

Parse the sink-message event. Unref `msg` after usage.

#### Parameters

event | The event to query |
msg | a pointer to store the GstMessage in. | [out][transfer full]

### gst_event_new_reconfigure ()

    GstEvent *
    gst_event_new_reconfigure (void);

Create a new reconfigure event. The purpose of the reconfigure event is to travel upstream and make elements renegotiate their caps or reconfigure their buffer pools. This is useful when changing properties on elements or changing the topology of the pipeline.

#### Returns

a new GstEvent.

[transfer full]

### gst_event_new_caps ()

    GstEvent *
    gst_event_new_caps (GstCaps *caps);

Create a new CAPS event for `caps` . The caps event can only travel downstream synchronized with the buffer flow and contains the format of the buffers that will follow after the event.

#### Parameters

caps | a GstCaps. | [transfer none]

#### Returns

the new CAPS event.

[transfer full][nullable]

### gst_event_parse_caps ()

    void
    gst_event_parse_caps (GstEvent *event,
                          GstCaps **caps);

Get the caps from `event` . The caps remains valid as long as `event` remains valid.

#### Parameters

event | The event to parse |
caps | A pointer to the caps. | [out][transfer none]

### gst_event_new_toc ()

    GstEvent *
    gst_event_new_toc (GstToc *toc,
                       gboolean updated);

Generate a TOC event from the given `toc` . The purpose of the TOC event is to inform elements that some kind of the TOC was found.

#### Parameters

toc | GstToc structure. | [transfer none]
updated | whether `toc` was updated or not. |

#### Returns

a new GstEvent.

[transfer full]

### gst_event_parse_toc ()

    void
    gst_event_parse_toc (GstEvent *event,
                         GstToc **toc,
                         gboolean *updated);

Parse a TOC `event` and store the results in the given `toc` and `updated` locations.

#### Parameters

event | a TOC event. |
toc | pointer to GstToc structure. | [out][transfer full]
updated | pointer to store TOC updated flag. | [out]

### gst_event_new_toc_select ()

    GstEvent *
    gst_event_new_toc_select (const gchar *uid);

Generate a TOC select event with the given `uid` . The purpose of the TOC select event is to start playback based on the TOC's entry with the given `uid` .

#### Parameters

uid | UID in the TOC to start playback from. |

#### Returns

a new GstEvent.

### gst_event_parse_toc_select ()

    void
    gst_event_parse_toc_select (GstEvent *event,
                                gchar **uid);

Parse a TOC select `event` and store the results in the given `uid` location.

#### Parameters

event | a TOC select event. |
uid | storage for the selection UID. | [out][transfer full][allow-none]

### gst_event_new_segment_done ()

    GstEvent *
    gst_event_new_segment_done (GstFormat format,
                                gint64 position);

Create a new segment-done event. This event is sent by elements that finish playback of a segment as a result of a segment seek.

#### Parameters

format | The format of the position being done |
position | The position of the segment being done |

#### Returns

a new GstEvent.

[transfer full]

### gst_event_parse_segment_done ()

    void
    gst_event_parse_segment_done (GstEvent *event,
                                  GstFormat *format,
                                  gint64 *position);

Extracts the position and format from the segment done message.

#### Parameters

event | A valid GstEvent of type GST_EVENT_SEGMENT_DONE. |
format | Result location for the format, or `NULL`. | [out][allow-none]
position | Result location for the position, or `NULL`. | [out][allow-none]

### gst_event_new_protection ()

    GstEvent *
    gst_event_new_protection (const gchar *system_id,
                              GstBuffer *data,
                              const gchar *origin);

Creates a new event containing information specific to a particular protection system (uniquely identified by `system_id` ), by which that protection system can acquire key(s) to decrypt a protected stream.

In order for a decryption element to decrypt media protected using a specific system, it first needs all the protection system specific information necessary to acquire the decryption key(s) for that stream. The functions defined here enable this information to be passed in events from elements that extract it (e.g., ISOBMFF demuxers, MPEG DASH demuxers) to protection decrypter elements that use it.

Events containing protection system specific information are created using gst_event_new_protection, and they can be parsed by downstream elements using gst_event_parse_protection.

In Common Encryption, protection system specific information may be located within ISOBMFF files, both in movie (moov) boxes and movie fragment (moof) boxes; it may also be contained in ContentProtection elements within MPEG DASH MPDs. The events created by gst_event_new_protection contain data identifying from which of these locations the encapsulated protection system specific information originated. This origin information is required as some protection systems use different encodings depending upon where the information originates.

The events returned by `gst_event_new_protection()` are implemented in such a way as to ensure that the most recently-pushed protection info event of a particular `origin` and `system_id` will be stuck to the output pad of the sending element.

#### Parameters

system_id | a string holding a UUID that uniquely identifies a protection system. | [transfer none]
data | a GstBuffer holding protection system specific information. The reference count of the buffer will be incremented by one. | [transfer none]
origin | a string indicating where the protection information carried in the event was extracted from. The allowed values of this string will depend upon the protection scheme. |

#### Returns

a GST_EVENT_PROTECTION event, if successful; `NULL` if unsuccessful.

Since: 1.6

### gst_event_parse_protection ()

    void
    gst_event_parse_protection (GstEvent *event,
                                const gchar **system_id,
                                GstBuffer **data,
                                const gchar **origin);

Parses an event containing protection system specific information and stores the results in `system_id` , `data` and `origin` . The data stored in `system_id` , `origin` and `data` are valid until `event` is released.

#### Parameters

event | a GST_EVENT_PROTECTION event. |
system_id | pointer to store the UUID string uniquely identifying a content protection system. | [out][allow-none][transfer none]
data | pointer to store a GstBuffer holding protection system specific information. | [out][allow-none][transfer none]
origin | pointer to store a value that indicates where the protection information carried by `event` was extracted from. | [out][allow-none][transfer none]

Since: 1.6

### gst_event_new_select_streams ()

    GstEvent *
    gst_event_new_select_streams (GList *streams);

Allocate a new select-streams event.

The select-streams event requests the specified `streams` to be activated.

The list of `streams` corresponds to the "Stream ID" of each stream to be activated. Those ID can be obtained via the GstStream objects present in GST_EVENT_STREAM_START, GST_EVENT_STREAM_COLLECTION or GST_MESSAGE_STREAM_COLLECTION.

Note: The list of `streams` can not be empty.

#### Parameters

streams | the list of streams to activate. | [element-type utf8][transfer none]

#### Returns

a new select-streams event or `NULL` in case of an error (like an empty streams list).

[transfer full]

Since: 1.10

### gst_event_parse_select_streams ()

    void
    gst_event_parse_select_streams (GstEvent *event,
                                    GList **streams);

Parse the SELECT_STREAMS event and retrieve the contained streams.

#### Parameters

event | The event to parse |
streams | the streams. | [out][element-type utf8][transfer full]

Since: 1.10

### gst_event_new_stream_collection ()

    GstEvent *
    gst_event_new_stream_collection (GstStreamCollection *collection);

Create a new STREAM_COLLECTION event. The stream collection event can only travel downstream synchronized with the buffer flow.

Source elements, demuxers and other elements that manage collections of streams and post GstStreamCollection messages on the bus also send this event downstream on each pad involved in the collection, so that activation of a new collection can be tracked through the downstream data flow.

#### Parameters

collection | Active collection for this data flow |

#### Returns

the new STREAM_COLLECTION event.

[transfer full]

Since: 1.10

### gst_event_parse_stream_collection ()

    void
    gst_event_parse_stream_collection (GstEvent *event,
                                       GstStreamCollection **collection);

Retrieve new GstStreamCollection from STREAM_COLLECTION event `event` .

#### Parameters

event | a stream-collection event |
collection | pointer to store the collection. | [out]

Since: 1.10

### gst_event_new_stream_group_done ()

    GstEvent *
    gst_event_new_stream_group_done (guint group_id);

Create a new Stream Group Done event. The stream-group-done event can only travel downstream synchronized with the buffer flow. Elements that receive the event on a pad should handle it mostly like EOS, and emit any data or pending buffers that would depend on more data arriving and unblock, since there won't be any more data.

This event is followed by EOS at some point in the future, and is generally used when switching pads - to unblock downstream so that new pads can be exposed before sending EOS on the existing pads.

#### Parameters

group_id | the group id of the stream group which is ending |

#### Returns

the new stream-group-done event.

[transfer full]

Since: 1.10

### gst_event_parse_stream_group_done ()

    void
    gst_event_parse_stream_group_done (GstEvent *event,
                                       guint *group_id);

Parse a stream-group-done `event` and store the result in the given `group_id` location.

#### Parameters

event | a stream-group-done event. |
group_id | address of variable to store the group id into. | [out]

Since: 1.10

## Types and Values

### struct GstEvent

    struct GstEvent {
      GstMiniObject mini_object;

      GstEventType  type;
      /* FIXME 2.0: Remove the GstEvent::timestamp field */
      guint64       timestamp;
      guint32       seqnum;
    };

A GstEvent.

#### Members

GstMiniObject `mini_object`; | the parent structure |
GstEventType `type`; | the GstEventType of the event |
guint64 `timestamp`; | the timestamp of the event |
guint32 `seqnum`; | the sequence number of the event |

### enum GstEventTypeFlags

GstEventTypeFlags indicate the aspects of the different GstEventType values. You can get the type flags of a GstEventType with the `gst_event_type_get_flags()` function.

#### Members

GST_EVENT_TYPE_UPSTREAM | Set if the event can travel upstream. |
GST_EVENT_TYPE_DOWNSTREAM | Set if the event can travel downstream. |
GST_EVENT_TYPE_SERIALIZED | Set if the event should be serialized with data flow. |
GST_EVENT_TYPE_STICKY | Set if the event is sticky on the pads. |
GST_EVENT_TYPE_STICKY_MULTI | Multiple sticky events can be on a pad, each identified by the event name. |

### GST_EVENT_TYPE_BOTH

    #define             GST_EVENT_TYPE_BOTH

The same thing as GST_EVENT_TYPE_UPSTREAM | GST_EVENT_TYPE_DOWNSTREAM.

### enum GstEventType

GstEventType lists the standard event types that can be sent in a pipeline.

The custom event types can be used for private messages between elements that can't be expressed using normal GStreamer buffer passing semantics. Custom events carry an arbitrary GstStructure. Specific custom events are distinguished by the name of the structure.

#### Members

GST_EVENT_UNKNOWN | unknown event. |
GST_EVENT_FLUSH_START | Start a flush operation. This event clears all data from the pipeline and unblock all streaming threads. |
GST_EVENT_FLUSH_STOP | Stop a flush operation. This event resets the running-time of the pipeline. |
GST_EVENT_STREAM_START | Event to mark the start of a new stream. Sent before any other serialized event and only sent at the start of a new stream, not after flushing seeks. |
GST_EVENT_CAPS | GstCaps event. Notify the pad of a new media type. |
GST_EVENT_SEGMENT | A new media segment follows in the dataflow. The segment events contains information for clipping buffers and converting buffer timestamps to running-time and stream-time. |
GST_EVENT_STREAM_COLLECTION | A new GstStreamCollection is available (Since 1.10) |
GST_EVENT_TAG | A new set of metadata tags has been found in the stream. |
GST_EVENT_BUFFERSIZE | Notification of buffering requirements. Currently not used yet. |
GST_EVENT_SINK_MESSAGE | An event that sinks turn into a message. Used to send messages that should be emitted in sync with rendering. |
GST_EVENT_STREAM_GROUP_DONE | Indicates that there is no more data for the stream group ID in the message. Sent before EOS in some instances and should be handled mostly the same. (Since 1.10) |
GST_EVENT_EOS | End-Of-Stream. No more data is to be expected to follow without either a STREAM_START event, or a FLUSH_STOP and a SEGMENT event. |
GST_EVENT_TOC | An event which indicates that a new table of contents (TOC) was found or updated. |
GST_EVENT_PROTECTION | An event which indicates that new or updated encryption information has been found in the stream. |
GST_EVENT_SEGMENT_DONE | Marks the end of a segment playback. |
GST_EVENT_GAP | Marks a gap in the datastream. |
GST_EVENT_QOS | A quality message. Used to indicate to upstream elements that the downstream elements should adjust their processing rate. |
GST_EVENT_SEEK | A request for a new playback position and rate. |
GST_EVENT_NAVIGATION | Navigation events are usually used for communicating user requests, such as mouse or keyboard movements, to upstream elements. |
GST_EVENT_LATENCY | Notification of new latency adjustment. Sinks will use the latency information to adjust their synchronisation. |
GST_EVENT_STEP | A request for stepping through the media. Sinks will usually execute the step operation. |
GST_EVENT_RECONFIGURE | A request for upstream renegotiating caps and reconfiguring. |
GST_EVENT_TOC_SELECT | A request for a new playback position based on TOC entry's UID. |
GST_EVENT_SELECT_STREAMS | A request to select one or more streams (Since 1.10) |
GST_EVENT_CUSTOM_UPSTREAM | Upstream custom event |
GST_EVENT_CUSTOM_DOWNSTREAM | Downstream custom event that travels in the data flow. |
GST_EVENT_CUSTOM_DOWNSTREAM_OOB | Custom out-of-band downstream event. |
GST_EVENT_CUSTOM_DOWNSTREAM_STICKY | Custom sticky downstream event. |
GST_EVENT_CUSTOM_BOTH | Custom upstream or downstream event. In-band when travelling downstream. |
GST_EVENT_CUSTOM_BOTH_OOB | Custom upstream or downstream out-of-band event. |

### enum GstStreamFlags

#### Members

GST_STREAM_FLAG_NONE | This stream has no special attributes |
GST_STREAM_FLAG_SPARSE | This stream is a sparse stream (e.g. a subtitle stream), data may flow only in irregular intervals with large gaps in between. |
GST_STREAM_FLAG_SELECT | This stream should be selected by default. This flag may be used by demuxers to signal that a stream should be selected by default in a playback scenario. |
GST_STREAM_FLAG_UNSELECT | This stream should not be selected by default. This flag may be used by demuxers to signal that a stream should not be selected by default in a playback scenario, but only if explicitly selected by the user (e.g. an audio track for the hard of hearing or a director's commentary track). |

Since: 1.2

### enum GstQOSType

The different types of QoS events that can be given to the `gst_event_new_qos()` method.

#### Members

GST_QOS_TYPE_OVERFLOW | The QoS event type that is produced when upstream elements are producing data too quickly and the element can't keep up processing the data. Upstream should reduce their production rate. This type is also used when buffers arrive early or in time. |
GST_QOS_TYPE_UNDERFLOW | The QoS event type that is produced when upstream elements are producing data too slowly and need to speed up their production rate. |
GST_QOS_TYPE_THROTTLE | The QoS event type that is produced when the application enabled throttling to limit the data rate. |

### enum GstSeekType

The different types of seek events. When constructing a seek event with `gst_event_new_seek()` or when doing `gst_segment_do_seek()`.

#### Members

GST_SEEK_TYPE_NONE | no change in position is required |
GST_SEEK_TYPE_SET | absolute position is requested |
GST_SEEK_TYPE_END | relative position to duration is requested |

### enum GstSeekFlags

Flags to be used with `gst_element_seek()` or `gst_event_new_seek()`. All flags can be used together.

A non flushing seek might take some time to perform as the currently playing data in the pipeline will not be cleared.

An accurate seek might be slower for formats that don't have any indexes or timestamp markers in the stream. Specifying this flag might require a complete scan of the file in those cases.

When performing a segment seek: after the playback of the segment completes, no EOS will be emitted by the element that performed the seek, but a `GST_MESSAGE_SEGMENT_DONE` message will be posted on the bus by the element. When this message is posted, it is possible to send a new seek event to continue playback. With this seek method it is possible to perform seamless looping or simple linear editing.

When doing fast forward (rate > 1.0) or fast reverse (rate < -1.0) trickmode playback, the `GST_SEEK_FLAG_TRICKMODE` flag can be used to instruct decoders and demuxers to adjust the playback rate by skipping frames. This can improve performance and decrease CPU usage because not all frames need to be decoded.

Beyond that, the `GST_SEEK_FLAG_TRICKMODE_KEY_UNITS` flag can be used to request that decoders skip all frames except key units, and `GST_SEEK_FLAG_TRICKMODE_NO_AUDIO` flags can be used to request that audio decoders do no decoding at all, and simple output silence.

The `GST_SEEK_FLAG_SNAP_BEFORE` flag can be used to snap to the previous relevant location, and the `GST_SEEK_FLAG_SNAP_AFTER` flag can be used to select the next relevant location. If `GST_SEEK_FLAG_KEY_UNIT` is specified, the relevant location is a keyframe. If both flags are specified, the nearest of these locations will be selected. If none are specified, the implementation is free to select whichever it wants.

The before and after here are in running time, so when playing backwards, the next location refers to the one that will played in next, and not the one that is located after in the actual source stream.

Also see part-seeking.txt in the GStreamer design documentation for more details on the meaning of these flags and the behaviour expected of elements that handle them.

#### Members

GST_SEEK_FLAG_NONE | no flag |
GST_SEEK_FLAG_FLUSH | flush pipeline |
GST_SEEK_FLAG_ACCURATE | accurate position is requested, this might be considerably slower for some formats. |
GST_SEEK_FLAG_KEY_UNIT | seek to the nearest keyframe. This might be faster but less accurate. |
GST_SEEK_FLAG_SEGMENT | perform a segment seek. |
GST_SEEK_FLAG_TRICKMODE | when doing fast forward or fast reverse playback, allow elements to skip frames instead of generating all frames. (Since 1.6) |
GST_SEEK_FLAG_SKIP | Deprecated backward compatibility flag, replaced by `GST_SEEK_FLAG_TRICKMODE` |
GST_SEEK_FLAG_SNAP_BEFORE | go to a location before the requested position, if `GST_SEEK_FLAG_KEY_UNIT` this means the keyframe at or before the requested position the one at or before the seek target. |
GST_SEEK_FLAG_SNAP_AFTER | go to a location after the requested position, if `GST_SEEK_FLAG_KEY_UNIT` this means the keyframe at of after the requested position. |
GST_SEEK_FLAG_SNAP_NEAREST | go to a position near the requested position, if `GST_SEEK_FLAG_KEY_UNIT` this means the keyframe closest to the requested position, if both keyframes are at an equal distance, behaves like `GST_SEEK_FLAG_SNAP_BEFORE`. |
GST_SEEK_FLAG_TRICKMODE_KEY_UNITS | when doing fast forward or fast reverse playback, request that elements only decode keyframes and skip all other content, for formats that have keyframes. (Since 1.6) |
GST_SEEK_FLAG_TRICKMODE_NO_AUDIO | when doing fast forward or fast reverse playback, request that audio decoder elements skip decoding and output only gap events or silence. (Since 1.6) |

## See Also

GstPad, GstElement